Attribute VB_Name = "Module2"

  Public Declare Function midiOutOpen Lib "winmm.dll" (lphMidiOut As Long, ByVal uDeviceID As Long, ByVal dwCallback As Long, ByVal dwInstance As Long, ByVal dwFlags As Long) As Long

Public Declare Function midiOutShortMsg Lib "winmm.dll" (ByVal hMidiOut As Long, ByVal dwMsg As Long) As Long

Public Declare Function midiOutClose Lib "winmm.dll" (ByVal hMidiOut As Long) As Long

Public Declare Function midiOutReset Lib "winmm.dll" (ByVal hMidiOut As Long) As Long


'The MIDI handle is needed to use the midi device.
'We must not lose it.
Global MidiHandle As Long

 Function OpenMidi()
    'This Function opens the MIDI port so we
    'can start using it to play notes.
    midiOutOpen MidiHandle, -1, 0, 0, 0
End Function

 Function CloseMidi()
    'We MUST close the MIDI port, or we
    'and nothing else can re-open it without
    're-booting.
    midiOutClose MidiHandle
End Function

 Function PlayNote(Note As Long, _
 Channel As Long, Velocity As Long)
    'Dimension some variables.
    Dim CompleteMessage As Long
    Dim PartA As Long
    Dim PartB As Long
    
    'Work out what we are going to send.
    PartA = (Note * 256) + 143 + Channel
    PartB = (Velocity * 256) * 256
    CompleteMessage = PartA + PartB
    
    'Send the message.
    midiOutShortMsg MidiHandle, CompleteMessage
End Function

 Function ChangePatch(Channel As Long, Patch As Long)

    'Dimension some variables.
    Dim CompleteMessage As Long
    Dim PartA As Long
    Dim PartB As Long
    
    'Work out what we are going to send.
    MidiEventOut = &HC0 + (Channel - 1)
    Note = Patch
    Velocity = 0
    PartA = (Note * 256) + &HC0 + (Channel - 1)
    PartB = (Velocity * 256) * 256
    CompleteMessage = PartA + PartB
    
    'Send the message.
    midiOutShortMsg MidiHandle, CompleteMessage
    
End Function




